package com.example.request;

import org.eclipse.gef.commands.Command;
import org.eclipse.swt.graphics.RGB;

import com.example.model.Node;

/**
 * @author zhanghao
 *
 */
public class ChangeColorCommand extends Command {
	private Node node;

	private RGB color;

	private RGB oldColor;

	public RGB getColor() {
		return color;
	}

	public Node getNode() {
		return node;
	}

	public void setNode(Node node) {
		this.node = node;
	}

	public void setColor(RGB color) {
		this.color = color;
	}

	public ChangeColorCommand(Node node, RGB color) {
		super();
		this.color = color;
		this.node = node;
	}

	@Override
	public void execute() {
		oldColor = node.getColor();
		node.setColor(color);
	}

	@Override
	public void undo() {
		node.setColor(oldColor);
	}

}
