package com.example.request;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.tools.SelectionTool;
import org.eclipse.swt.graphics.RGB;

import com.example.model.Node;
import com.example.parts.NodePart;

/**
 * @author zhanghao
 *
 */
public class ChangeColorTool extends SelectionTool {
	private RGB color;

	public ChangeColorTool(RGB color) {
		super();
		this.color = color;
	}

	/**
	 * If target editpart is an {@link NodePart}, create a {@link ChangeColorRequest} instance, 
	 * get command from target editpart with this request and execute.
	 */
	@Override
	protected boolean handleButtonDown(int button) {
		//Get selected editpart
		EditPart editPart = this.getTargetEditPart();
		
		if (editPart instanceof NodePart) {
			NodePart nodePart = (NodePart) editPart;
			Node node = (Node) nodePart.getModel();
			
			//Create an instance of ChangeColorRequest
			ChangeColorRequest request = new ChangeColorRequest(node, color);
			
			//Get command from the editpart
			Command command = editPart.getCommand(request);
			
			//Execute the command
			this.getDomain().getCommandStack().execute(command);
			
			return true;
		}
		return false;
	}

}
