/*
 * Created on 2005-1-25
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.example.tools;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.CombinedTemplateCreationEntry;
import org.eclipse.gef.palette.ConnectionCreationToolEntry;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.SelectionToolEntry;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gef.requests.SimpleFactory;
import org.eclipse.swt.graphics.RGB;

import com.example.model.Node;
import com.example.request.ChangeColorToolEntry;

/**
 * @author zhanghao
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PaletteFactory {
	public static PaletteRoot createPalette() {
		PaletteRoot paletteRoot = new PaletteRoot();
		paletteRoot.addAll(createCategories(paletteRoot));
		return paletteRoot;
	}

	private static List createCategories(PaletteRoot root) {
		List categories = new ArrayList();

		categories.add(createControlGroup(root));
		categories.add(createComponentsDrawer());
		
		//Add color drawer
		categories.add(createColorDrawer());

		return categories;
	}

	private static PaletteContainer createControlGroup(PaletteRoot root) {
		PaletteGroup controlGroup = new PaletteGroup("Control Group");

		List entries = new ArrayList();
		ToolEntry tool = new SelectionToolEntry();
		entries.add(tool);
		root.setDefaultEntry(tool);

		tool = new ConnectionCreationToolEntry("Connection", "Create a connection", null, null, null);
		entries.add(tool);

		controlGroup.addAll(entries);
		return controlGroup;
	}

	private static PaletteContainer createComponentsDrawer() {

		PaletteDrawer drawer = new PaletteDrawer("Components");

		List entries = new ArrayList();
		ToolEntry tool = new CombinedTemplateCreationEntry("Node", "Create a new Node", Node.class, new SimpleFactory(
				Node.class), null, null);
		entries.add(tool);

		drawer.addAll(entries);
		return drawer;
	}

	/**
	 * Color drawer
	 * @return
	 */
	private static PaletteContainer createColorDrawer() {

		PaletteDrawer drawer = new PaletteDrawer("Colors");

		List entries = new ArrayList();
		ToolEntry tool = new ChangeColorToolEntry(new RGB(255, 128, 128), "Red", "Change color to red", null, null);
		entries.add(tool);
		ToolEntry tool2 = new ChangeColorToolEntry(new RGB(128, 255, 128), "Green", "Change color to green", null, null);
		entries.add(tool2);
		ToolEntry tool3 = new ChangeColorToolEntry(new RGB(128, 128, 255), "Blue", "Change color to blue", null, null);
		entries.add(tool3);

		drawer.addAll(entries);
		return drawer;
	}
}